#include "as31glue.h"
#include "printf.h"
#include "paulmon2.h"
#include "malloc.h"
#include "playlist.h"


simm_id first_file;	/* of the active playlist */
simm_id last_file;	/* of the active playlist */

simm_id first_playlist;
simm_id active_playlist;
simm_id last_playlist;


/* limit the maximum subdirectory depth (number of recursive */
/* calls) so that we don't overflow the 8051's small stack */
/* avoiding stack-hogging printf calls will allow deeper subdirs */
#define MAX_SUBDIR_DEPTH 5

static xdata struct dirent_struct pl_fileinfo;
static unsigned char subdir_depth;


void fill_playlist_setup(void)
{
	subdir_depth=0;
}


void fill_playlist_by_dir(unsigned long pl_cluster) reentrant
{
	char dir,r;

	// Read in and cache this directory

	if (++subdir_depth > MAX_SUBDIR_DEPTH) return;
	dir = file_open_by_1st_cluster(pl_cluster);
	if (dir < 0) {
		subdir_depth--;
		return;		// unable to open directory
	}
	do_ide_loop(1);
	file_cache(dir, 0, 0xFFFFFFFF);  // request entire directory cached
	do {
		do_ide_loop(4);
		r = file_cache_work(dir);
		if (r == 2) pm2_exit();
	} while (r == 0);
	do_ide_loop(8);
	file_seek(dir, 0);

	while(!dir_read(dir, &pl_fileinfo)) {
		if (pl_fileinfo.attrib & 0x10) {
			if(pl_fileinfo.short_name[0] != '.') {
				printf("Enter Dir: %s (depth=%d)\r\n",
				   pl_fileinfo.long_name, (int)subdir_depth);
				fill_playlist_by_dir(pl_fileinfo.cluster);
				printf("Leaving Dir\r\n");
			}
		} else {
			printf("Processing: %s\r\n", pl_fileinfo.long_name);
		}
	}
	file_close(dir);
	subdir_depth--;
}


